%==========================================================================
% Semantic Flow for Complex-Event Recognition in Videos
% Segment a hind effective-part of symbolic string
% 2009. 12. 7. Suha Kwak, POSTECH.
%==========================================================================



function hind_effpart = hindEffPart(strpart)
% properties of a hind effective-part for an operator
	% 1. grouped by '&' and '|'
	% 2. grouped by a pair of parentheses
        % ex. A<B&(C<D)&E<F, 
            % for '<' after 'A', input strpart = 'B&(C<D)&E<F' and hind_effpart = 'B&(C<D)&E'
            % for '<' afger 'C', input strpart = 'D)&E<F'      and hind_effpart = 'D'



%% PRELIMINARY
load config



%% EFFECTIVE PART SEARCH
str_idx = 1;
while str_idx <= length(strpart)
    nest_paren_num = 0;
    
% search for a parenthesis pair -------------------------------------------
    if strpart(str_idx) == '('
        % grouped by parentheses
        nest_paren_num = nest_paren_num + 1;
        while nest_paren_num > 0
            str_idx = str_idx + 1;
            if str_idx > length(strpart)
                disp('hindEffPart: wrong input string - parenthesis matching');
                break;
            elseif strpart(str_idx) == '('
                nest_paren_num = nest_paren_num + 1;
            elseif strpart(str_idx) == ')'
                nest_paren_num = nest_paren_num - 1;
            else
                % skip (contents in the parentheses is not important)
            end
        end
        
% check around primitives -------------------------------------------------
    elseif strpart(str_idx) > 47 && strpart(str_idx) < 58
        % find the last digit of the primitive
        while strpart(str_idx + 1) > 47 && strpart(str_idx + 1) < 58
            str_idx = str_idx + 1;
            if str_idx == length(strpart)
                break;
            end
        end
        % grouped by '&' and '|': search more
        if str_idx < length(strpart) && (strpart(str_idx + 1) == no_ordering || strpart(str_idx + 1) == selection)
            str_idx = str_idx + 1;
        % end of the search
        else
            tail_pos = str_idx;
            break;
        end
        
% skip logical relations and unary temporal relations ---------------------
    elseif strpart(str_idx) == no_ordering || strpart(str_idx) == selection
        % grouping by '&' and '|' which appear after a parenthesis
        
    elseif strpart(str_idx) == iter_occur
        % just skip the operator '*'

% stop when a binary temporal relation or '(' appears ---------------------
    else
        break;
    end
    tail_pos = str_idx;
    
    str_idx = str_idx + 1;
end

hind_effpart = strpart(1 : tail_pos);
